/*--------------------------------------------------------------*/
//AT89S52   ֹALEź
//STC89C51RCֹALEź
//ALEƵΪʱӵ6Ƶ, Fosc = 12MHz ALE(30) = 2MHz
//In normal operation, ALE is emitted at a constant rate of 1/6 the oscillator frequency and may be 
//used for external timing or clocking purposes. Note, however, that one ALE pulse is skipped dur-
//ing each access to external data memory. 
//Time:	21:40 2009-5-13


/*--------------------------------------------------------------*/
//ͷļ
#include <AT89X52.H>

sfr ALE_SEL	= 0x8e;


/*--------------------------------------------------------------*/
//
sbit K1 = P3^4;		//ֹALEź
sbit K2 = P3^5;		//ALEź


/*--------------------------------------------------------------*/
//궨
#define Disable_ALE	 ALE_SEL |= 0x01;	//ֹALEź
#define Enable_ALE	 ALE_SEL &= ~0x01;	//ALEź


/*--------------------------------------------------------------*/
//ʱ500000+0us 
void delay500ms(void)
{
    unsigned char i,j,k;
    for(i=205;i>0;i--)
    for(j=116;j>0;j--)
    for(k=9;k>0;k--);
}


/*--------------------------------------------------------------*/
//
void main(void)
{
	while(1)
	{
		P1 = 0xff;
		delay500ms();
		
		if(!K1) Disable_ALE
		if(!K2)	Enable_ALE

		P1 = 0x00;
		delay500ms();
	}
}
